//************************************************************************//
//									  //
//  Copyright 2013 Bertram Kopf (bertram@ep1.rub.de)			  //
//  	      	   Julian Pychy (julian@ep1.rub.de)			  //
//          	   - Ruhr-Universität Bochum 				  //
//									  //
//  This file is part of Pawian.					  //
//									  //
//  Pawian is free software: you can redistribute it and/or modify	  //
//  it under the terms of the GNU General Public License as published by  //
//  the Free Software Foundation, either version 3 of the License, or 	  //
//  (at your option) any later version.	 	      	  	   	  //
//									  //
//  Pawian is distributed in the hope that it will be useful,		  //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of	  //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	  //
//  GNU General Public License for more details.	      		  //
//									  //
//  You should have received a copy of the GNU General Public License     //
//  along with Pawian.  If not, see <http://www.gnu.org/licenses/>.	  //
//									  //
//************************************************************************//

// AppBase class definition file. -*- C++ -*-
// Copyright 2012 Bertram Kopf

#pragma once

#include <iostream>
#include <vector>
#include <complex>
#include <map>
#include <string>
#include <memory>

#include <cassert>

#include "Event/EventList.hh"
// #include <memory>

class AbsLh;
class FitParamsBase;
class AbsEnv;
class fitParams;
class AbsHist;

class AppBase{

public:

  AppBase(AbsEnv* absEnv, std::shared_ptr<AbsLh> theLhPtr, std::shared_ptr<FitParamsBase> theFitParamBase);
  /** Destructor */
  virtual ~AppBase();

  //  static AppBase* instance();

  virtual void dumpDefaultParams();
  virtual void generate(fitParams& theParams);
  virtual void readEvents(EventList& theEventList, std::vector<std::string>& fileNames, bool withEvtWeight=false, int evtStart=0, int evtStop=1000000);
  virtual void qaMode(fitParams& theStartParams, double evtWeightSumData, int noOfFreeFitParams);

protected:

  AbsEnv* _absEnv;
  std::shared_ptr<AbsLh> _absLhPtr;
  std::shared_ptr<FitParamsBase> _fitParamBasePtr;

private:

};



